RidePal/RidePal/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using RidePal.Services.Contracts;
using RidePal.Web.Models;
using System;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace RidePal.Web.Controllers
{
    public class HomeController : Controller
    {
        private readonly IPlaylistService playlistService;
        private readonly ILogger<AccountController> logger;

        public HomeController(IPlaylistService playlistService, ILogger<AccountController> logger)
        {
            this.playlistService = playlistService ?? throw new ArgumentNullException(nameof(playlistService));
            this.logger = logger;
        }

        public async Task<IActionResult> Index()
        {
            var topRated = await playlistService.GetAllPlaylistsAsync();
            var viewModels = topRated.Take(3).Select(p => new PlaylistViewModel(p)).ToList();
            logger.LogInformation("Requested Index page.");

            return View(viewModels);
        }

        public IActionResult AboutUs()
        {
            logger.LogInformation("Requested AboutUs page.");
            return View();
        }

        public IActionResult PageNotFound()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

RidePal/RidePal/Controllers/PlaylistController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using RidePal.Services.Contracts;
using RidePal.Services.DTOs;
using RidePal.Web.Models;

namespace RidePal.Web.Controllers
{
    public class PlaylistController : Controller
    {
        private readonly IPlaylistService playlistService;
        public PlaylistController(IPlaylistService playlistService)
        {
            this.playlistService = playlistService ?? throw new ArgumentNullException(nameof(playlistService));
        }

        public async Task<IActionResult> Index(int? itemsCount, int? pageNumber)
        {
            ViewBag.playlistCount = await playlistService.GetPlaylistCountAsync();

            IEnumerable<PlaylistDTO> playlists = null;
            try
            {
                playlists = await playlistService.GetAllPlaylistsAsync(itemsCount.HasValue ? itemsCount.Value : 5, pageNumber.HasValue ? pageNumber.Value : 1);
            }
            catch (ArgumentException)
            {
                return View("Views/Home/NoContent.cshtml");
            }

            var collection = playlists.Select(playlist => new PlaylistViewModel(playlist)).ToList();
            return View(collection);
        }

        public async Task<JsonResult> FilterOnKeyUp(string criteria, string input, int pageNum)
        {
            var collection = await playlistService.FilterPlaylistsAsync(criteria, input);
            int count = playlistService.GetFilterPlaylistCountAsync(collection);

            var filteredCollection = playlistService.FilterPlaylistPaging(collection, pageIndex: pageNum);
            var viewModels = filteredCollection.Select(p => new PlaylistViewModel(p)).ToList();

            var jsonModel = new JSonPlaylistViewModel { Models = viewModels, Count = count }; // response.models

            return Json(jsonModel);
        }

        public async Task<JsonResult> DetailsJson(int id, int? itemsCount, int pageNum)
        {
            int count = await playlistService.GetTracksCountAsync(id);
            var tracks = await playlistService.GetTracksAsync(id, pageIndex: pageNum);

            var viewModels = tracks.Select(t => new TrackViewModel(t)).ToList();
            var jsonModel = new JsonTrackViewModel { Models = viewModels, Count = count };

            return Json(jsonModel);
        }

        public async Task<IActionResult> Details(int id, int? itemsCount, int? pageNumber)
        {
            if (id < 1)
            {
                return View("Views/Home/BadRequest.cshtml");
            }

            ViewBag.tracksCount = await playlistService.GetTracksCountAsync(id);
            IEnumerable<TrackDTO> tracks = null;
            try
            {
                tracks = await playlistService.GetTracksAsync(id, itemsCount.HasValue ? itemsCount.Value : 5, pageNumber.HasValue ? pageNumber.Value : 1);
            }
            catch (Exception)
            {
                return View("Views/Home/NoContent.cshtml");
            }

            var collection = tracks.Select(t => new TrackViewModel(t));
            return View(collection);
        }

        public async Task<IActionResult> Listen(int id)
        {
            if (id < 1)
            {
                return View("Views/Home/BadRequest.cshtml");
            }

            IEnumerable<TrackDTO> playlistPreview = null;
            try
            {
                playlistPreview = await playlistService.ListenToPlaylistAsync(id);
            }
            catch (Exception)
            {
                return View("Views/Home/NoContent.cshtml");
            }

            var collection = playlistPreview.Select(x => new TrackViewModel(x)).ToList();
            return View(collection);
        }
    }
}

RidePal/RidePal/Controllers/UserPlaylistController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using RidePal.Data.Models;
using RidePal.Services.Contracts;
using RidePal.Services.DTOs;
using RidePal.Web.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;


namespace RidePal.Web.Controllers
{
    [Authorize(Roles = "Admin, User")]
    public class UserPlaylistController : Controller
    {
        private readonly ILogger<HomeController> logger;
        private readonly UserManager<User> userManager;
        private readonly IUserPlaylistService userPlaylistService;

        public UserPlaylistController(ILogger<HomeController> logger, IUserPlaylistService userPlaylistService, UserManager<User> userManager)
        {
            this.logger = logger;
            this.userManager = userManager ?? throw new ArgumentNullException(nameof(userManager));
            this.userPlaylistService = userPlaylistService ?? throw new ArgumentNullException(nameof(userPlaylistService));
        }

        // GET: UserPlaylist
        public async Task<IActionResult> Index(int? itemsCount, int? pageNumber)
        {
            var userId = int.Parse(this.userManager.GetUserId(this.User));
            ViewBag.playlistCount = await userPlaylistService.GetPlaylistsForUserCountAsync(userId);

            var playlistDTOs = await this.userPlaylistService.GetPlaylistsForUserAsync(userId, itemsCount.HasValue ? itemsCount.Value : 5, pageNumber.HasValue ? pageNumber.Value : 1);
            var result = playlistDTOs.Select(x => new PlaylistViewModel(x));

            return View(result);
        }

        // GET: UserPlaylist/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: UserPlaylist/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(GeneratePlaylistViewModel playlist)
        {
            var tuple1 = Tuple.Create("Rock", playlist.Percentage1);
            var tuple2 = Tuple.Create("Metal", playlist.Percentage2);
            var tuple3 = Tuple.Create("Jazz", playlist.Percentage3);
            var tuple4 = Tuple.Create("Classical", playlist.Percentage4);
            var tuple5 = Tuple.Create("Rap/Hip Hop", playlist.Percentage5);
            List<Tuple<string, int>> tempTupleList = new List<Tuple<string, int>> { tuple1, tuple2, tuple3, tuple4, tuple5 };
            List<Tuple<string, int>> tupleList = new List<Tuple<string, int>>();
            for (int i = 0; i < tempTupleList.Count; i++)
            {
                if (tempTupleList[i].Item2 > 0)
                {
                    tupleList.Add(tempTupleList[i]);
                }
            }

            var userId = int.Parse(this.userManager.GetUserId(this.User));

            PlaylistDTO playlistDTO = null;
            if (ModelState.IsValid)
            {
                try
                {
                    playlistDTO = await this.userPlaylistService.GeneratePlaylistAsync(tupleList, playlist.StartPoint, playlist.EndPoint,
                                                                         playlist.Title, userId);
                }
                catch (Exception)
                {
                    return View("Views/Home/BadRequest.cshtml");
                }

                logger.LogInformation("Playlist with title {0} was generated by user with id: {1}.", playlist.Title, userId);
                return RedirectToAction("Details", "Playlist", new { id = playlistDTO.Id });
            }

            return View(playlistDTO);
        }

        // GET: UserPlaylist/Edit/5
        public async Task<IActionResult> Edit(int id)
        {
            if (id < 1)
            {
                return View("Views/Home/BadRequest.cshtml");
            }

            var userId = int.Parse(this.userManager.GetUserId(this.User));
            PlaylistDTO playlist = null;
            try
            {
                playlist = await this.userPlaylistService.GetPlaylistAsync(id);
            }
            catch (Exception)
            {
                return View("Views/Home/NoContent.cshtml");
            }

            if (playlist.UserId != userId && userId != 1)
            {
                return View("Views/Home/Forbidden.cshtml");
            }
            var result = new PlaylistViewModel(playlist);
            return View(result);
        }

        // POST: UserPlaylist/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(PlaylistViewModel playlist)
        {
            if (ModelState.IsValid)
            {
                var result = await this.userPlaylistService.EditPlaylistAsync(playlist.Id, playlist.Title);
                if (result == true)
                {
                    logger.LogInformation("Playlist with id: {0}'s name was edited to {1}.", playlist.Id, playlist.Title);
                    return RedirectToAction(nameof(Index));
                }

                return View("Views/Home/BadRequest.cshtml");
            }
            return View(playlist);
        }

        // GET: UserPlaylist/Delete/5
        public async Task<IActionResult> Delete(int id)
        {
            if (id < 1)
            {
                return View("Views/Home/BadRequest.cshtml");
            }

            var userId = int.Parse(this.userManager.GetUserId(this.User));
            PlaylistDTO playlist = null;
            try
            {
                playlist = await this.userPlaylistService.GetPlaylistAsync(id);
            }
            catch (Exception)
            {
                return View("Views/Home/NoContent.cshtml");
            }

            if (playlist.UserId != userId && userId != 1)
            {
                return View("Views/Home/Forbidden.cshtml");
            }
            var result = new PlaylistViewModel(playlist);
            return View(result);
        }

        // POST: UserPlaylist/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var result = await this.userPlaylistService.DeletePlaylistAsync(id);

            if (result == true)
            {
                logger.LogInformation("Playlist with id: {0} was deleted.", id);
                return RedirectToAction(nameof(Index));
            }
            else
            {
                return View("Views/Home/BadRequest.cshtml");
            }
        }
    }
}

RidePal/RidePal/Views/Home/AboutUs.cshtml
@{
    ViewData["Title"] = "AboutUs";
}


<center>
    <table id="abouttable" class="table table-borderless" style="background-color:transparent">
        <tbody>
            <tr style="border:initial;">
                <td>
                    <div class="table table-borderless" style="background-color: rgba(0, 0, 0, 0.6); width:350px">
                        <img class="card-img-top rcorners" src="~/images/atanas.jpg" alt="Card image">
                        <div class="card-body">
                            <center> <h4 class="card-title">Atanas Velev</h4></center>
                            <center> <p class="card-text"><b><i>ASP.NET Core developer</i></b></p></center>
                            <center> <p class="card-text"><b><i>Email: atanasgeorgievvelev@gmail.com</i></b></p></center>
                        </div>
                    </div>
                </td>

                <td>
                    <h2 style="color:orange">RidePal&copy; Team</h2>
                </td>

                <td>
                    <div class="table table-borderless" style="background-color: rgba(0, 0, 0, 0.6); width:350px">
                        <img class="card-img-top rcorners" src="~/images/nevena.jpg" alt="Card image">
                        <div class="card-body">
                            <center> <h4 class="card-title">Nevena Georgieva</h4></center>
                            <center> <p class="card-text"><b><i>ASP.NET Core developer</i></b></p></center>
                            <center> <p class="card-text"><b><i>Email: nevenageorgieva@gmail.com</i></b></p></center>
                        </div>
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</center>

RidePal/RidePal/Views/Home/BadRequest.cshtml
<div class="text-center">
    <img src="~/images/Doggo.jpg" />
    <br />
    <h1>400 Bad Request</h1> <br />
    <a asp-controller="Home" asp-action="Index" class="btn btn-outline-warning" role="button">Home</a>
</div>

RidePal/RidePal/Views/Home/Forbidden.cshtml
<div class="text-center">
    <img src="~/images/Doggo.jpg" />
    <br />
    <h1>403 Forbidden</h1> <br />
    <a asp-controller="Home" asp-action="Index" class="btn btn-outline-warning" role="button">Home</a>
</div>

RidePal/RidePal/Views/Home/Index.cshtml
@model IEnumerable<PlaylistViewModel>
@{
    ViewData["Title"] = "Home Page";
}
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<div class="text-center">

    <h2 style="color:orange">Our Top Rated Playlists</h2> <br />

    <table class="table table-borderless" style="background-color: rgba(0, 0, 0, 0.6);">
        <thead>
            <tr>
                <th><b>Title</b></th>
                <th><b>Average Rank</b></th>
                <th><b>Total Playtime</b></th>
                <th><b>Genres</b></th>
                <th><b>Details</b></th>
                <th><b>Play</b></th>
                @if (User.IsInRole("Admin"))
                {
                    <th><center><b>Edit</b></center></th>
                    <th><center><b>Delete</b></center></th>
                }
            </tr>
        </thead>
        <tbody>
            @foreach (var item in Model)
            {
                <tr style="border: 0 none;">
                    <td>
                        <i>@Html.DisplayFor(modelItem => item.Title)</i>

                    </td>

                    <td>
                        <i>@Html.DisplayFor(modelItem => item.AverageRank)</i>
                    </td>
                    <td>
                        <i>@Html.DisplayFor(modelItem => item.TotalDuration) mins</i>
                    </td>
                    <td>
                        <i>@Html.DisplayFor(modelItem => item.Genres)</i>
                    </td>
                    <td>
                        <center>
                            <a asp-controller="Playlist" asp-action="Details" asp-route-id="@item.Id" class="gg-readme" role="button"></a>
                        </center>

                    </td>
                    <td>
                        <center>
                            <a asp-controller="Playlist" asp-action="Listen" asp-route-id="@item.Id" class="gg-play-button-o" role="button"></a>
                        </center>
                    </td>

                    @if (User.IsInRole("Admin"))
                    {
                        <td>
                            <a asp-controller="UserPlaylist" asp-action="Edit" asp-route-id="@item.Id" class="fa fa-edit" style="font-size:larger" role="button"></a>
                        </td>
                        <td>
                            <a asp-controller="UserPlaylist" asp-action="Delete" asp-route-id="@item.Id"class="fa fa-close" style="font-size:larger" role="button"></a>
                        </td>
                    }
                </tr>
            }
        </tbody>
    </table>
    <p>
        <a asp-controller="UserPlaylist" asp-action="Create" class="btn btn-outline-warning" role="button">Generate your own playlist</a>
    </p>
    <br />
    <h5 style="color:orange;font-style:normal">Enjoy your ride, and don't forget:</h5>
    <h5 style="color: orange;font-style:normal">"Keep your eyes on the road, your hands upon the wheel &#9835;&#9835;"</h5>
    <br />
</div>

<div class="row">
    <div class="col-md-4">
    </div>
    <div class="col-md-4">
        <div id="carouselExampleCaptions" class="carousel slide" data-ride="carousel">
            <ol class="carousel-indicators">
                <li data-target="#carouselExampleCaptions" data-slide-to="0" class="active"></li>
                <li data-target="#carouselExampleCaptions" data-slide-to="1"></li>
                <li data-target="#carouselExampleCaptions" data-slide-to="2"></li>
                <li data-target="#carouselExampleCaptions" data-slide-to="3"></li>
                <li data-target="#carouselExampleCaptions" data-slide-to="4"></li>
                <li data-target="#carouselExampleCaptions" data-slide-to="5"></li>
                <li data-target="#carouselExampleCaptions" data-slide-to="6"></li>
                <li data-target="#carouselExampleCaptions" data-slide-to="7"></li>
                <li data-target="#carouselExampleCaptions" data-slide-to="8"></li>
            </ol>
            <div class="carousel-inner">
                <div class="carousel-item active">
                    <img src="./Images/carousel-1.jpg" class="d-block w-100" alt="...">
                </div>
                <div class="carousel-item">
                    <img src="./Images/carousel-2.jpg" class="d-block w-100" alt="...">
                </div>
                <div class="carousel-item">
                    <img src="./Images/carousel-3.jpg" class="d-block w-100" alt="...">
                </div>
                <div class="carousel-item">
                    <img src="./Images/carousel-4.jpg" class="d-block w-100" alt="...">
                </div>
                <div class="carousel-item">
                    <img src="./Images/carousel-5.jpg" class="d-block w-100" alt="...">
                </div>
                <div class="carousel-item">
                    <img src="./Images/carousel-6.jpg" class="d-block w-100" alt="...">
                </div>
                <div class="carousel-item">
                    <img src="./Images/carousel-7.jpg" class="d-block w-100" alt="...">
                </div>
                <div class="carousel-item">
                    <img src="./Images/carousel-8.jpg" class="d-block w-100" alt="...">
                </div>
            </div>
            <a class="carousel-control-prev" href="#carouselExampleCaptions" role="button" data-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="sr-only">Previous</span>
            </a>
            <a class="carousel-control-next" href="#carouselExampleCaptions" role="button" data-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="sr-only">Next</span>
            </a>
        </div>
    </div>
</div>

RidePal/RidePal/Views/Home/NoContent.cshtml
<div class="text-center">
    <img src="~/images/Doggo.jpg" />
    <br />
    <h1>204 No Content</h1> <br />
    <a asp-controller="Home" asp-action="Index" class="btn btn-outline-warning" role="button">Home</a>
</div>

RidePal/RidePal/Views/Home/PageNotFound.cshtml
<div class="text-center">
    <img src="~/images/Doggo.jpg" />
    <br />
    <h1>404 Page Not Found</h1> <br />
    <a asp-controller="Home" asp-action="Index" class="btn btn-outline-warning" role="button">Home</a>
</div>